SystemOrganization addCategory: #'DrGeoII-Polymorph'!

!UITheme methodsFor: '*DrGeoII-Polymorph-morph creation' stamp: 'HilaireFernandes 4/7/2010 10:18'!
newToolbarDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a toolbar drop list for the given model."

	^self
		newToolbarDropListIn: aThemedMorph
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!UITheme methodsFor: '*DrGeoII-Polymorph-morph creation' stamp: 'HilaireFernandes 4/7/2010 10:15'!
newToolbarDropListIn: aThemedMorph for: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a toolbar drop list for the given model."

	^(ToolbarDropListMorph
			on: aModel
			list: listSel
			selected: getSel
			changeSelected: setSel
			useIndex: useIndex)
		selectionColor: self selectionColor;
		getEnabledSelector: enabledSel;
		cornerStyle: aThemedMorph preferredCornerStyle;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		setBalloonText: helpText! !

StandardWindow subclass: #DrGeoWindow
	instanceVariableNames: 'app area'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!DrGeoWindow class methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/18/2010 22:54'!
in: aDrGeo 
	"A new model with an existing domain. For multiple MVP on a same
	Domain "
	^ super basicNew app: aDrGeo;
		 initialize! !

!DrGeoWindow class methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/18/2010 22:38'!
new
	"instanciate a standard DrGeo application"
	^ self in: DrGeoDomain new! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:18'!
addMenuItem: array to: menu
	menu 
		addToggle: array first translated
		target: self presenter
		selector: array third.
	menu lastItem
		font: self theme menuFont;
		icon: (DrGIcons scaled16: array second);
		setBalloonText: array fourth translated ! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:49'!
app 
	^ app ! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:53'!
app: aDrgeo
	app := aDrgeo! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/19/2010 12:39'!
area
	^ area! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/16/2010 18:22'!
button: actionType with: array
"actionType = array of symbol for action type, to track state of button
array first = button form
array second = symbol callback
array third = help string
"
	^ self
		newButtonFor: self presenter
		getState: #isTool:
		action: array third
		arguments: {actionType}
		getEnabled: nil
		labelForm: (DrGIcons scaled24: array second)
		help: array fourth translated.! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/14/2010 22:51'!
curveButtons
	^{
	self button: #line with: self presenter lineButtonData.
	self button: #parallel with: self presenter parallelButtonData.
	self button: #perpendicular with: self presenter perpendicularButtonData.
	self button: #ray with: self presenter rayButtonData.
	self button: #segment with: self presenter segmentButtonData.
	self button: #vector with: self presenter vectorButtonData.
	self button: #circle with: self presenter circleButtonData.
	self button: #arc with: self presenter arcButtonData.
	self button: #polygon with: self presenter polygonButtonData.
	self button: #locus with: self presenter locusButtonData 
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:27'!
curveMenu
	| lineMenu |
	lineMenu := self newMenu.
	self addMenuItem: self presenter lineButtonData to: lineMenu.
	self addMenuItem: self presenter parallelButtonData to: lineMenu.
	self addMenuItem: self presenter perpendicularButtonData to: lineMenu.
	self addMenuItem: self presenter rayButtonData to: lineMenu.
	self addMenuItem: self presenter segmentButtonData to: lineMenu.
	self addMenuItem: self presenter vectorButtonData to: lineMenu.
	self addMenuItem: self presenter circleButtonData to: lineMenu.
	self addMenuItem: self presenter arcButtonData to: lineMenu.
	self addMenuItem: self presenter polygonButtonData to: lineMenu.
	self addMenuItem: self presenter locusButtonData to: lineMenu.
	^ lineMenu
		! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/9/2010 08:30'!
curveToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ (self 
		newToolbarDropListFor:  (ListModel new list: self curveButtons )
		list: #list 
		getSelected: #selectionIndex 
		setSelected: #selectionIndex: 
		help: 'Create different curve types: line, half-line, segment, vector, circle...' translated)! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:52'!
domain
	^ app domain ! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/26/2010 10:30'!
fileMenu
	| fileMenu |
	fileMenu := self newMenu.
	fileMenu
		addToggle: 'New' translated
		target: self presenter
		selector: #newFigure.
	fileMenu 
		addToggle: 'Open' translated
		target: self presenter
		selector: #openFigure. 
	fileMenu 
		addToggle: 'Save' translated
		target:  self presenter
		selector: #saveFigure.
	^ fileMenu
		! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 4/19/2010 07:34'!
initialize
	super initialize.
	self model: self domain.
	self changed: #relabel.
"	self view presenter: self presenter.
	self presenter view: app."
	area := DrGDrawable newOn: app.
	self installTools.
	self presenter move.! !

!DrGeoWindow methodsFor: 'initialization' stamp: 'HilaireFernandes 4/27/2010 08:33'!
installTools
	| bar shiftY|

	bar := self mainMenu.
	shiftY := bar minExtent y.
	self 
		addMorph: bar  
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@0 corner: 0@shiftY)).
	bar := self miscToolbar.
	self 
		addMorph: bar 
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@shiftY corner: 0@ (shiftY + bar minExtent y))).
	shiftY := shiftY + bar minExtent y.
	bar := self toolbars.
	self 
		addMorph: bar
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@0) 
			offsets: (0@shiftY corner: 0@(shiftY + bar minExtent y))).
	shiftY := shiftY + bar minExtent y.

	self 
		addMorph: area 
		fullFrame: (LayoutFrame 
			fractions: (0@0 corner: 1@1) 
			offsets: (0@shiftY corner: -25@ -25)).

	self
		addMorph: self presenter verticalWheel
		fullFrame: (LayoutFrame 
			fractions: (1 @ 1 corner: 1 @ 1) 
			offsets: (-25@ -120 corner: 0@ -20)).
	self
		addMorph: self presenter horizontalWheel
		fullFrame: (LayoutFrame 
			fractions: (1 @ 1 corner: 1 @ 1) 
			offsets: (-120@ -25 corner: -20@0)).
	self
	 	addMorph: self presenter zoomWheel 
		fullFrame: (LayoutFrame 
			fractions: (1 @ 0 corner: 1 @ 0) 
			offsets: (-25@shiftY corner: 0@(shiftY + 100))).
	self themeChanged;
		openInWorld ! !

!DrGeoWindow methodsFor: 'testing' stamp: 'HilaireFernandes 4/19/2010 10:32'!
isApplication 
	^true! !

!DrGeoWindow methodsFor: 'testing' stamp: 'HilaireFernandes 4/19/2010 10:31'!
isService
	^false! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/15/2010 07:39'!
macroconstructionButtons
	^{
	self button: #macroBuild with: self presenter macroBuildButtonData.
	self button: #macroPlay with: self presenter macroExecuteButtonData. 
	self button: #deleteMacro with: self presenter macroDeleteButtonData.
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:27'!
macroconstructionMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter macroBuildButtonData to: menu.
	self addMenuItem: self presenter macroExecuteButtonData to: menu.
	self addMenuItem: self presenter macroDeleteButtonData to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/9/2010 09:02'!
macroconstructionToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ (self 
		newToolbarDropListFor:  (ListModel new list: self macroconstructionButtons)
		list: #list 
		getSelected: #selectionIndex 
		setSelected: #selectionIndex: 
		help: 'Build or execute macro-construction. A macro is a construction template you can apply to items in the sketch area.' translated)! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/9/2010 09:16'!
mainMenu
	| menuBar |
	menuBar := self newToolDockingBar.
	menuBar
		add: 'File' translated
		font: self theme menuBarFont
		icon: nil
		help: 'Load, save or export Dr. Geo figure.' translated
		subMenu: self fileMenu.
	menuBar 
		add: 'Points' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Create points: free, on curve, intersection or middle point.' translated 
		subMenu: self pointMenu.
	menuBar 
		add: 'Lines' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Create different curve types: line, half-line, segment, vector, circle...' translated 
		subMenu: self curveMenu.
	menuBar 
		add: 'Transformations' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Transform an object with a geometric transformation: symmetry, reflexion, rotation, translation or homothety (scale).' translated 
		subMenu: self transformationMenu.
	menuBar 
		add: 'Numerics' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Create several numeric objects: free value, distance, length, angle, coordinates, equation and script.' translated 
		subMenu: self numericMenu.
	menuBar 
		add: 'Macro-construction' translated
		font: self theme menuBarFont
		icon: nil 
		help: 'Build or execute macro-construction. A macro is a construction template you can apply to items in the sketch area.' translated 
		subMenu: self macroconstructionMenu.
		
	^ menuBar 
! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/19/2010 12:55'!
miscToolbar
	|tools|
	tools := self newToolbar: {
		self button: #move with: self presenter moveButtonData.
		self button: #style with: self presenter styleButtonData.
		self button: nil with: self presenter undoButtonData.
		self button: nil with: self presenter redoButtonData.
		self button: #eraser with: self presenter eraserButtonData.
		self
			newButtonFor: self presenter
			getState: #isGridVisible
			action: #gridOnOff
			arguments: nil
			getEnabled: nil
			labelForm: (DrGIcons scaled24: #grid)
			help: 'Show or hide grid.' translated.	
		self
			newButtonFor: self presenter
			getState: #isGridded
			action: #gridStuckOnOff
			arguments: nil
			getEnabled: nil
			labelForm: (DrGIcons scaled24: #gridMagnet)
			help: 'Snap to grid.' translated.			
			
			}.
	^ self newToolDockingBar addMorph: tools! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/15/2010 07:42'!
numericButtons
	^{
	self button: #distance with: self presenter distanceButtonData.
	self button: #angle with: self presenter angleButtonData.
	self button: #coordinates with: self presenter coordinatesButtonData.
	self button: #editScript with: self presenter scriptEditButtonData.
	self button: #useScript with: self presenter scriptButtonData.
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:42'!
numericMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter distanceButtonData to: menu.
	self addMenuItem: self presenter angleButtonData to: menu.
	self addMenuItem: self presenter coordinatesButtonData  to: menu.
	self addMenuItem: self presenter scriptEditButtonData to: menu.
	self addMenuItem: self presenter scriptButtonData  to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/9/2010 08:57'!
numericToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ (self 
		newToolbarDropListFor:  (ListModel new list: self numericButtons)
		list: #list 
		getSelected: #selectionIndex 
		setSelected: #selectionIndex: 
		help: 'Create several numeric objects: free value, distance, length, angle, coordinates, equation and script.' translated)! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/15/2010 07:44'!
pointButtons
	^{
	self button: #freePoint with: self presenter freePointButtonData.
	self button: #middleButton with: self presenter middleButtonData.
	self button: #pointByCoordinates with: self presenter pointByCoordinatesButtonData.
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:19'!
pointMenu
	| pointMenu |
	pointMenu := self newMenu.
	self addMenuItem: self presenter freePointButtonData to: pointMenu.
	self addMenuItem: self presenter middleButtonData to: pointMenu.
	self addMenuItem: self presenter pointByCoordinatesButtonData  to: pointMenu.
	^ pointMenu
		! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/9/2010 08:29'!
pointToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ (self 
		newToolbarDropListFor:  (ListModel new list: self pointButtons )
		list: #list 
		getSelected: #selectionIndex 
		setSelected: #selectionIndex: 
		help: 'Create points: free, on curve, intersection or middle point.' translated)! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/26/2010 07:47'!
popupMenu 
"we don't want the popup menu when using the rich UI"! !

!DrGeoWindow methodsFor: 'accessing' stamp: 'HilaireFernandes 4/18/2010 22:47'!
presenter 
	^ app presenter! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/9/2010 09:08'!
toolbars
	|tools|
	tools := self newToolbar: {
		self pointToolbar. self newToolSpacer.
		self curveToolbar. self newToolSpacer.
		self transformationToolbar. self newToolSpacer.
		self numericToolbar. self newToolSpacer.
		self macroconstructionToolbar}.
	^ self newToolDockingBar addMorph: tools! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/15/2010 07:47'!
transformationButtons
	^{
	self button: #symmetry with: self presenter symmetryButtonData.
	self button: #reflection with: self presenter reflectionButtonData.
	self button: #translation with: self presenter translationButtonData.
	self button: #rotation with: self presenter rotationButtonData.
	self button: #homothety with: self presenter homothetyButtonData.
	}! !

!DrGeoWindow methodsFor: 'menus' stamp: 'HilaireFernandes 4/16/2010 17:43'!
transformationMenu
	| menu |
	menu := self newMenu.
	self addMenuItem: self presenter symmetryButtonData to: menu.
	self addMenuItem: self presenter reflectionButtonData to: menu.
	self addMenuItem: self presenter translationButtonData to: menu.
	self addMenuItem: self presenter rotationButtonData to: menu.
	self addMenuItem: self presenter homothetyButtonData to: menu.
	^ menu
		! !

!DrGeoWindow methodsFor: 'toolbars' stamp: 'HilaireFernandes 4/9/2010 09:16'!
transformationToolbar
"Voir la classe ListModel, on utilise changed: pour notifier la modif du model"
	^ (self 
		newToolbarDropListFor:  (ListModel new list: self transformationButtons )
		list: #list 
		getSelected: #selectionIndex 
		setSelected: #selectionIndex: 
		help: 'Transform an object with a geometric transformation: symmetry, reflexion, rotation, translation or homothety (scale).' translated)! !

!TEasilyThemed methodsFor: '*DrGeoII-Polymorph-controls' stamp: 'HilaireFernandes 4/7/2010 10:29'!
newToolbarDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel help: helpText
	"Answer a toolbar drop list for the given model."

	^self 
		newToolbarDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: true
		help: helpText! !

!TEasilyThemed methodsFor: '*DrGeoII-Polymorph-controls' stamp: 'HilaireFernandes 4/7/2010 10:28'!
newToolbarDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel getEnabled: enabledSel useIndex: useIndex help: helpText
	"Answer a toolbar drop list for the given model."

	^self theme
		newToolbarDropListIn: self
		for: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: enabledSel
		useIndex: useIndex
		help: helpText! !

!TEasilyThemed methodsFor: '*DrGeoII-Polymorph-controls' stamp: 'HilaireFernandes 4/7/2010 10:30'!
newToolbarDropListFor: aModel list: listSel getSelected: getSel setSelected: setSel help: helpText
	"Answer a toolbar drop list for the given model."

	^self 
		newToolbarDropListFor: aModel
		list: listSel
		getSelected: getSel
		setSelected: setSel
		getEnabled: nil
		useIndex: true
		help: helpText! !

MorphDropListMorph subclass: #ToolbarDropListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/10/2010 11:46'!
hideList
	"Hide the list."

	self listMorph ifNil: [^self].
	self listVisible ifFalse: [^self].
	self listMorph delete.
	self listMorph changeModelSelection: self listMorph selectionIndex.
	self roundedCorners: #(1 2 3 4).
	(self buttonMorph ifNil: [^self]) roundedCorners: (self roundedCorners copyWithoutAll: #(1 2)).
	self changed.
	self wantsKeyboardFocus
		ifTrue: [self takeKeyboardFocus]! !

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/9/2010 08:27'!
list: aCollection
	"Set the list contents."
	| maxExtent |
	maxExtent := 0@0.
	list := aCollection.
	list do: [:aMorph | aMorph lock.
		maxExtent := maxExtent max: aMorph extent].
	self contentMorph;
		minWidth: maxExtent x;
		minHeight: maxExtent y.
	self changed: #list.
	self listSelectionIndex: 1! !

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/8/2010 21:20'!
listHeight
	"Answer the height for the list."
	^self listMorph listMorph height + 19! !

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/9/2010 09:39'!
listMorphClass
	"Answer the class for a new list morph"

	^PluggableToolbarMorph! !

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/7/2010 13:10'!
newContentMorph
	 "answer a new content morph"
	^Morph new
		changeTableLayout;
		listDirection: #leftToRight;
		wrapCentering: #center;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		layoutInset: 0;
		color: Color transparent;
		borderWidth: 0;
		clipSubmorphs: true! !

!ToolbarDropListMorph methodsFor: 'as yet unclassified' stamp: 'HilaireFernandes 4/10/2010 12:15'!
updateContents
	"Update the contents."

	|item|
	self contentMorph removeAllMorphs.
	self listSelectionIndex > 0
		ifTrue: [item := (self list at: self listSelectionIndex) copy unlock;
					hResizing: #spaceFill;
					vResizing: #spaceFill.
				item performAction.
				self contentMorph
					addMorph: item]! !

PluggableMorphListMorph subclass: #PluggableToolbarMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'DrGeoII-Polymorph'!
